package ch.hevs.gdx2d.demos.shaders.advanced;

import ch.hevs.gdx2d.desktop.PortableApplication;
import ch.hevs.gdx2d.lib.GdxGraphics;

/**
 * Shows how to interwind shaders and normal GDX operations
 *
 * @author Pierre-André Mudry (mui)
 * @version 0.1
 */
public class DemoShaderPartialTextureRendering extends PortableApplication {

	double t = 0;

	public static void main(String[] args) {
		new DemoShaderPartialTextureRendering();
	}

	@Override
	public void onInit() {
		this.setTitle("Partial screen shader demo, mui 2013");
	}

	@Override
	public void onGraphicRender(GdxGraphics g) {
		if (g.getShaderRenderer() == null)
			g.setShader("data/shader/bicolor.fp", 200, 200);

		g.clear();
		g.drawFPS();
		g.drawShader(256, (int) (256 + 128.0 * Math.sin(t)), 0);
		g.drawSchoolLogo();

		t += 0.05;
	}
}
